@********************************************************************
@*   crt0.S v1.26 by Jeff Frohwein									*
@*   -- heavliy modified by Stephen Stair                           *
@*		I'll do my own interrupts thank you :)						*
@********************************************************************



    .TEXT

    .GLOBAL     _start
_start:
        .ALIGN
        .CODE 32
    @ Start Vector

        b       rom_header_end

    @ Nintendo Logo Character Data (8000004h)
        .fill   156,1,0

    @ Game Title (80000A0h)
		.ascii	"GBAHearts   "
@        .byte   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
@        .byte   0x00,0x00,0x00,0x00

    @ Game Code (80000ACh)
        .ascii  "MB  "

    @ Maker Code (80000B0h)
        .byte   0x30,0x31

    @ Fixed Value (80000B2h)
        .byte   0x96

    @ Main Unit Code (80000B3h)
        .byte   0x00

    @ Device Type (80000B4h)
        .byte   0x00

    @ Unused Data (7Byte) (80000B5h)
        .byte   0x00,0x00,0x00,0x00,0x00,0x00,0x00

    @ Software Version No (80000BCh)
        .byte   0x00

    @ Complement Check (80000BDh)
        .byte   0xf0

    @ Checksum (80000BEh)
        .byte   0x00,0x00

    .ALIGN
    .ARM                                @ ..or you can use CODE 32 here

rom_header_end:
        b       start_vector        @ This branch must be here for proper
                                    @ positioning of the following header.
                                    @ DO NOT REMOVE IT.

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@ The following reserved bytes are used if the code is compiled for      @
@ multiboot mode. It does not hurt anything to leave this header in
@ even if the code is not compiled for multiboot. The GBA BIOS will
@ auto-patch the first two bytes with 0x03 and 0x01, respectively,
@ before running any code if it is executed as multiboot.
@

@ The following two bytes are included even for non-multiboot supporting
@ builds to guarantee that any generic library code that depends on them
@ will still be functional.

    .GLOBAL     __boot_method, __slave_number

__boot_method:
        .byte   0       @ boot method (0=ROM boot, 3=Multiplay boot)
__slave_number:
        .byte   0       @ slave # (1=slave#1, 2=slave#2, 3=slave#3)


        .byte   0       @ reserved
        .byte   0       @ reserved
        .word   0       @ reserved
        .word   0       @ reserved
        .word   0       @ reserved
        .word   0       @ reserved
        .word   0       @ reserved
        .word   0       @ reserved
@                                                                        @
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


@@@@@@@@@@@@@@@@@@@@@@
@        Reset       @
@@@@@@@@@@@@@@@@@@@@@@
		.ascii " GBAHearts by Stephen Stair (sgstair) |"
		.ascii " Copyright 2002 Stephen Stair |"
		.ascii " Written for GBADEV.ORG hearts competition |"
		.ascii " www.interspecialty.com/sgstair "

    .GLOBAL     start_vector
    .ALIGN
    .ARM                                @ ..or you can use CODE 32 here
start_vector:
		mov		r0,pc,lsr #24
		cmp		r0,#0x02			@ are we in exwram?
        ldr	r3,=AgbMain
        bxeq	r3
	
		@ nope, let's dma ourselves in :)
		
		mov r4,#0x04000000
		mov r0,#0x08000000
		mov r1,#0x02000000
		mov r2,#256*1024		@copy 256k
		str r0,[r4,#0xD4]
		str r1,[r4,#0xD8]
		strh r2,[r4,#0xDC]
		mov r0,#0x8400
		strh r0,[r4,#0xDE]	@start dma

		@ ok we're copied! let's go!
		bx r3

    .ALIGN
    .POOL


    .END


