

// 8bit bitmap mode defines

// GetPixelPair: x should be even
#define GetPixelPair(x,y,screen) VRAM[((screen)?(240*80+(x)/2+(y)*120):((x)/2+(y)*120))]
#define GetPixel(x,y,screen) ((x)%2?GetPixelPair(x,y,screen)&0x0ff:GetPixelPair(x,y,screen)>>8)

#define DrawPixelPair(x,y,screen,colors) VRAM[(screen)?(240*80+(x)/2+(y)*120):((x)/2+(y)*120)]=(colors)
//DrawFirstPixel/DrawSecondPixel: x should be even
#define DrawFirstPixel(x,y,screen,color) DrawPixelPair(x,y,screen,(GetPixelPair(x,y,screen)&0x0ff00)|(color))
#define DrawSecondPixel(x,y,screen,color) DrawPixelPair(x,y,screen,(GetPixelPair(x,y,screen)&0x0ff)|((color)<<8))
#define DrawPixel(x,y,screen,color) if((x)%2){DrawSecondPixel(x,y,screen,color);} else {DrawFirstPixel(x,y,screen,color);}



// OAM macros:
#define OamA(chr,a) OAM[((chr)*4)+(a)]
#define RotScale(grp,prm) OAM[((grp)*16)+((prm)*4)+3]


void wait_vblank(void);
void killOam(void);
void SetOamZoom(u8 grp,u16 zoom);
void RLE16decompress(u16 *source,u16 *dest,u32 uncompsize);
void DrawCard(s16 x,s16 y,u8 card,u8 screen,u8 orientation);
void DrawCardNoOvr(s16 x,s16 y,u8 card,u8 screen,u8 orientation);
void ClearBox(u16 x1,u16 y1,u16 x2,u16 y2,u8 screen,u8 color);
void SetMode4(u8 screen,u8 sprites);
u32 SpritePrint(u8 ch,s16 x, s16 y, u8 pitch, char * text,s8 rs,u8 pal);

void ShowWindow(u8 win);
void HideWindow(u8 win);
void SetWindowPos(u8 win,u8 x1,u8 x2,u8 y1,u8 y2);
void SetOamRSZoom(u8 grp,u8 ang,u16 zoom);
void SetOamRS(u8 grp,u8 ang);
void SetSprite(u8 ch, s16 x, s16 y, u16 spr,s8 rs, s8 pal);




