#include "gbahearts.h"

const struct GBCsounddata sounddata[]= {
	{1,0x08,0x80,0xf1,0xf0,0x86},	// select
	{1,0x75,0x80,0xf2,0x40,0x84},	// accept
	{1,0x4C,0x80,0xf2,0x50,0x84},	// back
	{1,0x00,0x80,0xf0,0x00,0xc1},	// reject
	{4,0x00,0x00,0x71,0x01,0x80}	// card move
};

void PlayGBCSound(u8 soundnum) {
	u16 L0,H0,X1;
	if(soundnum==0) return;
	soundnum--;
		L0=sounddata[soundnum].NRx0;
		H0=sounddata[soundnum].NRx1|(sounddata[soundnum].NRx2<<8);
		X1=sounddata[soundnum].NRx3|(sounddata[soundnum].NRx4<<8);
	switch(sounddata[soundnum].soundtype) {
	case 1:
		SG10_L=L0;
		SG10_H=H0;
		SG11=X1;
		break;
	case 2:
		SG20=H0;
		SG21=X1;
		break;
	case 3:
		SG30_L=L0;
		SG30_H=H0;
		SG31=X1;
		break;
	case 4:
		SG40=H0;
		SG41=X1;
		break;
	}

}

void SetupGBCSound(void) {
	SGCNT1=0x0080;
	SGCNT0_H=2;
	SGCNT0_L=0xff77;

}
