#include "gbahearts.h"

u8 AIlevel;
u32 Gamemode;
u8 passtype,curplayer,curscreen,curdealer;
struct carddeck Deck;
struct heartplayer player[4];
struct hearttrick trick[13];
u32 passcards[4];
u32 temp1,temp2,temp3;
u8 tricknum,trickcards;
u8 counterplayed;	// flag

const char dispcharu[]="ABCDEFGHIJKLMNOPQRSTUVWXYZ()";
const char dispcharl[]="abcdefghijklmnopqrstuvwxyz.!";


u8 GetCardSortValue(u8 cardnum) {
	u8 cardval;
	cardval=CardValue(cardnum);
	if(cardval==0) cardval=13;
	cardval--;
	switch(CardSuit(cardnum)) {
	case SUIT_CLUBS:
		return cardval;
	case SUIT_DIAMONDS:
		return cardval+13;
	case SUIT_SPADES:
		return cardval+26;
	case SUIT_HEARTS:
		return cardval+39;
	default:
		return 255;
	}
}
 
u8 GetCardPointValue(u8 cardnum) {
	if(CardSuit(cardnum)==SUIT_HEARTS) return 1;
	if(cardnum==CardNum(SUIT_SPADES,CARD_QUEEN)) return 13;
	return 0;
}
u8 GetCardTakeValue(u8 cardnum, u8 suitplayed) {
	u8 crd;
	if(CardSuit(cardnum)!=suitplayed) return 0;
	crd=CardValue(cardnum);
	if(crd==0) crd=13;
	return crd;
}
u8 CardOkToPlay(u8 card) {
	if(tricknum==0 && trickcards==0 && card!=CardNum(SUIT_CLUBS,CARD_TWO)) return 0;
//	if(trickcards==0 && counterplayed==0 && GetCardPointValue(card)!=0) return 0;
//	if(tricknum==0 && GetCardPointValue(card)!=0) return 0;
	return 1;
}

void SortCards(u8 * card,u8 numcards) {
	u8 i,j,sn,sv;
	u8 cardtmp[13];
	for(i=0;i<numcards;i++) 
		cardtmp[i]=card[i];
	for(i=0;i<numcards;i++) {
		sv=255;sn=0;
		for(j=0;j<numcards;j++) {
			if(GetCardSortValue(cardtmp[j])<sv) {
				sv=GetCardSortValue(cardtmp[j]);sn=j;
			}
		}
		card[i]=cardtmp[sn];
		cardtmp[sn]=255;
	}
}

void EPNDrawName(char * name,u8 ch) {
	u32 i;
	for(i=0;i<ch;i++) {
		OamA(i,0)=40;
		OamA(i,1)=120-ch*5+i*10;
		OamA(i,2)=(512+name[i]) | 0x1000;
	}
	for(i=ch;i<20;i++)
		OamA(i,0)=161;
}
u32 EnterPlayerName(void) {
	char tmpname[20];
	u16 tempmode;
	u16 a,b;
	u8 selx,sely;
	u8 shift;
	u8 ch;
	u8 animstp;
	for(ch=0;ch<20;ch++) tmpname[ch]=myname[ch];
	for(ch=0;ch<9;ch++) if(tmpname[ch]==0) break;
	BGPAL[0]=31*32;
	for(a=0;a<32;a++) SPRPAL[a]=0;
	if(ch==0) shift=1; else shift=0;
	killOam();
	tempmode=DISPCNT;
	DISPCNT=0x1000;	// obj only
	SpritePrint(112,45,16,10,"Enter Your Name",-1,0);
//	SpritePrint(0,20,40,10,"____________________",-1,1);
	EPNDrawName(tmpname,ch);
	selx=0;sely=0;
	animstp=0;
	do {
		// update matrix
		for(a=0;a<4;a++) {
			for(b=0;b<7;b++) {
				if(selx==b && sely==a) {
					OamA(20+b+a*7,0)=(60+20*a-4) | 0x0300;
					OamA(20+b+a*7,1)=(50+20*b-4);
					OamA(20+b+a*7,2)=512+(shift?dispcharu:dispcharl)[a*7+b];
				} else {
					OamA(20+b+a*7,0)=(60+20*a);
					OamA(20+b+a*7,1)=(50+20*b);
					OamA(20+b+a*7,2)=512+(shift?dispcharu:dispcharl)[a*7+b];
				}
			}
		}
		if(sely==4 && selx==0) 
			SpritePrint(48,10-4,140-4,10,"Back",0,0);
		else SpritePrint(48,10,140,10,"Back",-1,0);
		if(sely==4 && selx==1) 
			SpritePrint(52,70-4,140-4,10,"Space",0,0);
		else SpritePrint(52,70,140,10,"Space",-1,0);
		if(sely==4 && selx==2) 
			SpritePrint(57,140-4,140-4,10,"Shift",0,0);
		else SpritePrint(57,140,140,10,"Shift",-1,0);
		if(sely==4 && selx==3) 
			SpritePrint(62,210-4,140-4,10,"Ok",0,0);
		else SpritePrint(62,210,140,10,"Ok",-1,0);
		
		b=animstp++;
		for(a=0;a<8;a++) {
			SPRPAL[17+a]=b%32;
			b+=7-a;
		}
		SetOamZoom(0,ZoomSin[b%32]);

		wait_vblank();
		UpdateKeys();

		if(KeyPressed(KEY_UP)) {
			PlayGBCSound(1);
			if(sely==1 || sely==2 || sely==3) {
				sely--;
			} else if(sely==0) {
				sely=4;
				selx=selx/2;
			} else {
				sely=3;
				selx=selx*2;
			}
		}
		if(KeyPressed(KEY_DN)) {
			PlayGBCSound(1);
			if(sely==3) {
				sely=4;
				selx=selx/2;
			} else if(sely==4) {
				sely=0;
				selx=selx*2;
			} else {
				sely++;
			}
		}
		if(KeyPressed(KEY_LF)) {
			PlayGBCSound(1);
			if(sely==4) {
				selx=(selx+3)%4;
			} else {
				selx=(selx+6)%7;
			}
		}
		if(KeyPressed(KEY_RT)) {
			PlayGBCSound(1);
			if(sely==4) {
				selx=(selx+1)%4;
			} else {
				selx=(selx+1)%7;
			}
		}
		if(KeyPressed(KEY_B)) {
			if(ch>0) {
				PlayGBCSound(1);
				ch--;
				if(ch==0) shift=1;
				EPNDrawName(tmpname,ch);
			} else {
				PlayGBCSound(4);
			}
		}
		if(KeyPressed(KEY_A) || KeyPressed(KEY_SEL)) {
			if(sely==4) {
				switch(selx) {
				case 0:	// Back
					if(ch>0) {
						PlayGBCSound(1);
						ch--;
						if(ch==0) shift=1;
						EPNDrawName(tmpname,ch);
					} else {
						PlayGBCSound(4);
					}
					break;
				case 1:	// Space
					if(ch<11) {
						PlayGBCSound(1);
						tmpname[ch]=' ';
						if(ch==0) shift=0;
						ch++;
						EPNDrawName(tmpname,ch);
					} else {
						// play sound
					}
					break;
				case 2:	// Shift
					PlayGBCSound(1);
					shift = shift^1;
					break;
				case 3: // Ok
					if(ch==0) {
						PlayGBCSound(4);
						break;
					}
					PlayGBCSound(2);
					for(a=0;a<ch;a++) myname[a]=tmpname[a];
					myname[a]=0;
					DISPCNT=tempmode;
					return 0;
					break;
				}
			} else {
				if(ch<11) {
					PlayGBCSound(1);
					tmpname[ch]=(shift?dispcharu:dispcharl)[sely*7+selx];
					if(ch==0) shift=0;
					ch++;
					EPNDrawName(tmpname,ch);
				} else {
					PlayGBCSound(4);
				}
			}
		}

	} while(1);

	DISPCNT=tempmode;
	return 0;
}

const char  CompNames[][10] = {
	"Joe", "Randy", "Calvin", "Bill", "Larry", "Bob", "Mary", "Jenny" 
};

void SetupSinglePlay(void) {
	int a,b,c;
	a=Random()%10; // get random names
	b=Random()%9;
	c=Random()%8;
	if(b>=a) b++;
	if(c>=a) c++;
	if(c>=b) c++;
	player[0].name=myname;
	player[0].PlayerType=0;
	player[0].Points=0;
	player[1].name=CompNames[a];
	player[1].PlayerType=1;
	player[1].Points=0;
	player[2].name=CompNames[b];
	player[2].PlayerType=1;
	player[2].Points=0;
	player[3].name=CompNames[c];
	player[3].PlayerType=1;
	player[3].Points=0;
}

u32 AISelectScreen(void) {
	u32 a,b,i;
	killOam();
	for(i=0;i<16;i++) SPRPAL[i]=0;
	SPRPAL[0]=0x7fff;
	SetOamZoom(0,0);
	SetOamZoom(1,0);
	SetOamZoom(2,0);
	a=SpritePrint(0,48,80,8,"AI level",-1,0);
	a+=SpritePrint(a,56,100,12,"Easy",0,0);
	a+=SpritePrint(a,44,120,12,"Medium",1,0);
	a+=SpritePrint(a,56,140,12,"Hard",2,0);

	for(i=0;i<17;i++) {
		wait_vblank();
		SetOamZoom(0,ZoomSin[i]-255);
		SetOamZoom(1,ZoomSin[i]-255);
		SetOamZoom(2,ZoomSin[i]-255);
	}
	b=0;
	i=0;
	do {
		wait_vblank();
		UpdateKeys();
		if(b==0) {
			SetOamZoom(1,256);
			SetOamZoom(2,256);
			SetOamZoom(0,ZoomSin[(i++)%32]);
		} else if(b==1) {
			SetOamZoom(0,256);
			SetOamZoom(2,256);
			SetOamZoom(1,ZoomSin[(i++)%32]);
		} else {
			SetOamZoom(0,256);
			SetOamZoom(1,256);
			SetOamZoom(2,ZoomSin[(i++)%32]);
		}
		if(KeyPressed(KEY_UP)) {
			PlayGBCSound(1);
			b=(b+2)%3;
		}
		if(KeyPressed(KEY_DN) || KeyPressed(KEY_SEL)) {
			PlayGBCSound(1);
			b=(b+1)%3;
		}
		if(KeyPressed(KEY_A) || KeyPressed(KEY_STR)) {
			PlayGBCSound(2);
			AIlevel=b;
			return PlayGame();
		}
		if(KeyPressed(KEY_B)) {
			PlayGBCSound(3);
			break;
		}

	}while(1);
	do {
		wait_vblank();
		if(b==0) {
			SetOamZoom(1,256);
			SetOamZoom(2,256);
			SetOamZoom(0,ZoomSin[(i++)%32]);
		} else if(b==1) {
			SetOamZoom(0,256);
			SetOamZoom(2,256);
			SetOamZoom(1,ZoomSin[(i++)%32]);
		} else {
			SetOamZoom(0,256);
			SetOamZoom(1,256);
			SetOamZoom(2,ZoomSin[(i++)%32]);
		}
	} while((i%32));
	for(i=17;i>0;i--) {
		wait_vblank();
		SetOamZoom(0,ZoomSin[i]-255);
		SetOamZoom(1,ZoomSin[i]-255);
		SetOamZoom(2,ZoomSin[i]-255);
	}
	return 0;
}


u32 MultiPlayScreen(void) {

return 1;
}

u8 HasCard(u8 p,u8 card) {
	u8 i;
	for(i=0;i<player[p].numcards;i++) {
		if(player[p].card[i]==card) return 1;
	}
	return 0;
}
u8 HasSuit(u8 p,u8 suit) {
	u8 i;
	for(i=0;i<player[p].numcards;i++) {
		if(CardSuit(player[p].card[i])==suit) return 1;
	}
	return 0;
}


// COMPUTER AI!!!!


u8 CompAICardRank(u8 card) {
	u8 crd;
	crd=CardValue(card);
	if(crd==0) crd=13;
	switch(CardSuit(card)) {
	case SUIT_CLUBS:
		return crd;
	case SUIT_SPADES:
		if(crd==CARD_QUEEN) return 50;
		return crd+5;
	case SUIT_DIAMONDS:
		return crd;
	case SUIT_HEARTS:
		return crd+10;
	}
	return 0;
}

u32 CompAICardPass(u8 p) {
	u32 diffrndcutoff;
	u8 a,b,c,n;
	u8 i,j;
	u8 crd[13];
	u8 crdval[13];
	a=b=c=n=0;
	if(AIlevel==0) diffrndcutoff=0x60000000;
	 else if(AIlevel==1) diffrndcutoff=0xA0000000;
	 else diffrndcutoff=0xF0000000;

	// find highest cards
	for(i=0;i<player[p].numcards;i++) crd[i]=player[p].card[i];
	for(i=0;i<player[p].numcards;i++) {
		b=0;c=0;
		for(j=0;j<player[p].numcards;j++) {
			if((CompAICardRank(crd[j]))>b) {
				b=CompAICardRank(crd[j]);
				c=j;
			}
		}
		crdval[i]=crd[c];
		crd[c]=255;
	}
	n=0;
	do {
		if(Random()>diffrndcutoff) {
			j=Random()%13;
			i=crdval[j];
			crdval[j]=255;
		} else {
			for(j=0;j<player[p].numcards;j++) {
				i=crdval[j];
				crdval[j]=255;
				if(i!=255) break;
			}
		}
		if(i!=255){
			if(n==0) a=i;
			if(n==1) b=i;
			if(n==2) c=i;
			n++;
		}
	}while(n<3);
	return a+(b<<8)+(c<<16);
}

u8 CompAIPlayCard(u8 p) {
	u32 diffrndcutoff;
	u8 i,j,k,he,sp,cl,di,qos,crd;
	he=sp=cl=di=qos=0;
	if(AIlevel==0) diffrndcutoff=0x60000000;
	 else if(AIlevel==1) diffrndcutoff=0xA0000000;
	 else diffrndcutoff=0xF0000000;
	// count cards out there, make our decision better..
	 for(i=0;i<tricknum;i++) {
		 for(j=0;j<4;j++) {
			crd=trick[i].card[j];
			if(CardSuit(crd)==SUIT_HEARTS) he++;
			if(CardSuit(crd)==SUIT_DIAMONDS) di++;
			if(CardSuit(crd)==SUIT_CLUBS) cl++;
			if(CardSuit(crd)==SUIT_SPADES) sp++;
			if(crd==CardNum(SUIT_SPADES,CARD_QUEEN)) qos++;
		 }
	 }
	if(HasCard(p,CardNum(SUIT_CLUBS,CARD_TWO))) return CardNum(SUIT_CLUBS,CARD_TWO);
	if(trickcards==0) {
		// we have to play any card we want..
		if(Random()>diffrndcutoff)
			return player[p].card[Random()%player[p].numcards];

		return player[p].card[0]; // since cards are nicely ordered


	} else {
		// try to follow suit, or else have fun :)

		crd=trick[tricknum].card[0];
		// as usual, incorperate a bit of randomness to make computers easier
		if(Random()>diffrndcutoff) {
			i=Random()%13;
			if(HasCard(p,CardNum(CardSuit(crd),i))) return CardNum(CardSuit(crd),i);
		}	
		j=CardValue(crd);
		// try to play under the trick
		if(j==0)j=13;
		for(i=j-1;i>0;i--) {
			if(HasCard(p,CardNum(CardSuit(crd),i))) return CardNum(CardSuit(crd),i);
		}
		// we can't play under it so try to take it with the biggest one
		for(i=13;i>j;i--) {
			k=i;
			if(k==13)k=0;
			if(HasCard(p,CardNum(CardSuit(crd),k))) return CardNum(CardSuit(crd),k);
		}
		// ok we don't have a card in that suit, let's pick a random card.
		// pleeeeeeease change this later!
			return player[p].card[Random()%player[p].numcards];

	}
	return 0;
}






void DrawTrick(u8 t,u8 crds) {
	u8 wd,i;
	ClearBox(60,22,180,130,0,0);
	tricknum=t;trickcards=crds;
	if(!crds) return;
	wd=(crds-1)*20+57;
	for(i=0;i<crds;i++) {
		if(trick[t].plr[i]==2) {
			DrawCard(120-(57/2),22,trick[t].card[i],0,0);
		}
	}
	for(i=0;i<crds;i++) {
		if(trick[t].plr[i]==1) {
			DrawCard(100-(57/2),45,trick[t].card[i],0,0);
		}
	}
	for(i=0;i<crds;i++) {
		if(trick[t].plr[i]==0) {
			DrawCard(120-(57/2),45,trick[t].card[i],0,0);
		}
	}
	for(i=0;i<crds;i++) {
		if(trick[t].plr[i]==3) {
			DrawCard(140-(57/2),45,trick[t].card[i],0,0);
		}
	}
	//for(i=0;i<crds;i++) {
	//	DrawCard(120-(wd/2)+20*i,25,trick[t].card[i],0,0);
	//}
}

void RedrawPlayerHand(u8 plr) {
	u32 i,wdth;

	switch(plr) {
	case 0: // local human (bottom, visible)
		// box at 19,136 to 220,159
		wdth=(player[plr].numcards-1)*12+57;
		ClearBox(19,136,220,159,curscreen,0);
		for(i=0;i<player[plr].numcards;i++)
			DrawCard(119-wdth/2+12*i,136,player[plr].card[i],curscreen,0);
		break;
	case 3: // ? (right, card backs)
		// box at 229,141 to 239,10
		ClearBox(229,10,239,141,curscreen,0);
		wdth=(player[plr].numcards-1)*6+57;
		for(i=0;i<player[plr].numcards;i++)
			DrawCard(229,75+wdth/2-i*6,CARDBACK,curscreen,2);

		break;
	case 2: // ? (right, card backs)
		// box at 19,0 to 220,9
		wdth=(player[plr].numcards-1)*12+57;

		ClearBox(19,0,220,9,curscreen,0);
		for(i=0;i<player[plr].numcards;i++)
			DrawCard(119+wdth/2-12*i,9,CARDBACK,curscreen,1);
		break;
	case 1: // ? (right, card backs)
		// box at 0,10 to 9,141
		ClearBox(0,10,9,141,curscreen,0);
		wdth=(player[plr].numcards-1)*6+57;
		for(i=0;i<player[plr].numcards;i++)
			DrawCard(9,75-wdth/2+i*6,CARDBACK,curscreen,3);
		break;
	}
}


void SendPlayerCard(u8 p,u8 card) {
	switch(player[p].PlayerType) {
	case 0: // local human
	case 1: // local computer
		if(player[p].numcards>12) return;	// ignore extra cards
		player[p].card[player[p].numcards]=card;
		player[p].numcards++;
		SortCards(player[p].card,player[p].numcards);
		break;
	case 2:	// remote player


		break;
	}
}
void RemovePlayerCard(u8 p, u8 card) {
	u8 i;
	switch(player[p].PlayerType) {
	case 0: // human
	case 1: // comp
		if(player[p].numcards==0)return; // no cards to remove!
		for(i=0;i<player[p].numcards;i++) {
			if(player[p].card[i]==card) {
				player[p].card[i]=player[p].card[player[p].numcards-1];
				player[p].numcards--;
				SortCards(player[p].card,player[p].numcards);
				return;
			}
		}
		break;
	case 2:	// remote

		break;
	}
}

void RequestPassCards(u8 p, u8 passtype) {
	u8 i;
	switch(player[p].PlayerType) {
	case 0:
		temp1=passtype<<24;	// temp1=current selected item (top byte=passtype)
					// 0-12 cards, 13-ok
		temp2=0;	// temp2=current selected cards
					// 0xaabbccdd aa=num cards selected
					// bb=card 1, cc= card 2  dd= card 3
		temp3=0;	// tracks frame (for gfx)
		for(i=0;i<16;i++) SPRPAL[i]=0;
		for(i=16;i<32;i++) SPRPAL[i]=15*32*32+15*32+15;
		break;
	}
}

const char passmsg[][15]= {
	"to pass left", "to pass right", "to pass across" };

u32 GetPassCards(u8 p) {
	u8 i,a,b,c,n;
	switch(player[p].PlayerType) {
	case 0:
		SpritePrint(5,64,50,8,"Select 3 cards",-1,0);
		SpritePrint(20,64,60,8,passmsg[temp1>>24],-1,0);
		if(temp2>>24!=3)
			SpritePrint(40,115,100,10,"Ok",1,1);
		else 
			SpritePrint(40,115,100,10,"Ok",1,0);

		if((temp1&255)<13) {
			OamA(0,0)=0x0300 | (160-42);
			OamA(0,1)=21+(temp1&255)*12;
			OamA(0,2)=512+25;
			SetOamZoom(0,ZoomSin[(temp3++)%32]);
			SetOamZoom(1,256);
		} else {
			OamA(0,0)=171;
			SetOamRSZoom(1,(ZoomSin[((temp3/2)+8)%32]/16)-24,ZoomSin[(temp3)%32]);
			temp3++;
		}
		a=((temp2>>16)&255);b=((temp2>>8)&255);c=((temp2)&255);
		n=((temp2>>24)&255);

		for(i=1;i<4;i++) {
			if(i<(n+1)) {
				OamA(i,0)=160-34;
				if(i==1) OamA(i,1)=22+12*a;
				if(i==2) OamA(i,1)=22+12*b;
				if(i==3) OamA(i,1)=22+12*c;
				OamA(i,2)=512+'.';
			} else {
				OamA(i,0)=171;
			}
		}
		i=temp1&255;
		if(KeyPressed(KEY_A)) {
			if(i==13) {
				PlayGBCSound(2);
				for(i=0;i<50;i++) OamA(i,0)=171;
				return player[p].card[a] | (player[p].card[b]<<8) |
					(player[p].card[c] << 16);
			}

			if(i==a && n) {
				PlayGBCSound(3);
				a=b;b=c;
				n--;
			} else if(i==b && n>1) {
				PlayGBCSound(3);
				b=c;
				n--;
			} else if(i==c && n>2) {
				PlayGBCSound(3);
				n--;
			} else {
				if(n<3) {
					PlayGBCSound(2);
					if(n==0)a=i;
					if(n==1)b=i;
					if(n==2)c=i;
					n++;
				} else {
					PlayGBCSound(4);
				}
			}
		}
		if(KeyPressed(KEY_LF)) {
			if(i!=13) {
				PlayGBCSound(1);
				i=(i+12)%13;
			}
		}
		if(KeyPressed(KEY_RT) | KeyPressed(KEY_SEL)) {
			if(i!=13) {
				PlayGBCSound(1);
				i=(i+1)%13;
			}
		}	
		if(KeyPressed(KEY_UP) | KeyPressed(KEY_DN)) {
			if(i!=13) {
				if(n==3) {
					PlayGBCSound(1);
					i=13;
				} else {
					PlayGBCSound(4);
				}
			} else {
				PlayGBCSound(1);
				i=0;
			}
		}
		temp1=(temp1&0xffffff00)|i;
		temp2=(n<<24)|(a<<16)|(b<<8)|c;


		break;
	case 1:
		return CompAICardPass(p);
	}
	return 0;
}


u8 PlayCard(u8 p) {
u8 i,j,sel,cntr,wdth,nc;
	switch(player[p].PlayerType) {
	case 0:// huuuman
		cntr=0;
		sel=0;
		wdth=(player[p].numcards-1)*12+57;
		nc=player[p].numcards;
			SpritePrint(1,42,100,12,"Select a Card",1,1);
		for(i=0;i<16;i++) SPRPAL[i]=0;
		do {
			wait_vblank();
			UpdateKeys();


			OamA(0,0)=0x0300 | (160-42);	// show cursor
			OamA(0,1)=119+2-(wdth/2)+12*sel;
			OamA(0,2)=512+25;
			SetOamZoom(0,ZoomSin[(cntr++)%32]);
			SetOamRSZoom(1,(ZoomSin[(cntr/4)%32]/8)-48,ZoomSin[(cntr/2+12)%32]);

			// update changing palette:
			for(i=16;i<32;i++) {
				j=(i+cntr/2)%32;
				if(j>16) j=31-j;
				SPRPAL[i]=2*j*32*32;
			}
			// move cursor
			if(KeyPressed(KEY_LF)) {
				PlayGBCSound(1);
				sel=(sel+nc-1)%nc;
			}
			if(KeyPressed(KEY_RT) | KeyPressed(KEY_SEL)) {
				PlayGBCSound(1);
				sel=(sel+1)%nc;
			}
			if(KeyPressed(KEY_A)) {
				i=CardOkToPlay(player[p].card[sel]);
				// make sure player isn't playing out of suit
				if(trickcards && HasSuit(p,CardSuit(trick[tricknum].card[0]))) {
					if(CardSuit(player[p].card[sel])!=CardSuit(trick[tricknum].card[0]))
						i=0;
				}
				
				if(i==1) {
					PlayGBCSound(2);
					for(i=0;i<30;i++) OamA(i,0)=170;
					return player[p].card[sel];
				} else {
					PlayGBCSound(4);
				}
			}
		}while(1);

	case 1:// computer

		return CompAIPlayCard(p);
	case 2:// remote
		return 0;
	}
	return 0;
}






// x,y,x,y,x,y,x,y
const u8 playrnamepos[]= {
	39,160-34,
	12,20,
	120,12,
	220,160-109
};
const u8 scorepos[] = {
	19,160-34,
	12,10,
	100,12,
	212,160-119
};


void ShowHeartsTaken() {
	u8 taken[4];
	u8 i,j,k;
	taken[0]=taken[1]=taken[2]=taken[3]=0;
	for(i=0;i<tricknum+1;i++) {
		k=0;
		for(j=0;j<4;j++) {
			k+=GetCardPointValue(trick[i].card[j]);
		}
		taken[trick[i].owner]+=k;
	}
	u8 x,y;
	k=86;
	for(i=0;i<4;i++) {
		x=scorepos[i*2];
		y=scorepos[i*2+1];
		// first digit
		SetSprite(k--,x,y,taken[i]/10+'0',-1,5);
		x+=8;
		// second digit
		SetSprite(k--,x,y,taken[i]%10+'0',-1,5);
	}

}

void DrawPlayerNames(void) {
	u8 p,i,s;
	u8 x,y;
	char c;
	s=127;
	for(p=0;p<4;p++) {
		x=playrnamepos[p*2];
		y=playrnamepos[p*2+1];
		for	(i=0;i<10;i++) {
			c=player[p].name[i];
			if(c==0) break;
			OamA(s,0)=y;
			OamA(s,1)=x;
			OamA(s,2)=(512+c) | 0xf000;	// palette 15
			s--;
			if(p%2) y+=10; else x+=10;
		}
	}
}
// game mode: 0-init, 1=deal, 2-pass, 3-play, 4-scores
// passtype: 0- pass left, 1- pass right, 2 - pass across

u32 PlayGame(void) {
	u32 i,j,k,l,m;
	curscreen=0;
	Gamemode=0;

	curdealer=0;
	killOam();
	DrawPlayerNames();
	for(i=240;i<255;i++) SPRPAL[i]=31*32*32;
	do {
		wait_vblank();
		UpdateKeys();

	
		switch(Gamemode) {
		case 0:
			killOam();
			ClearBox(0,0,300,300,0,0);
			BGPAL[0]=31*32;
			for(i=1;i<10;i++) BGPAL[i]=cardpal[i];
			SetMode4(0,1);
			DrawPlayerNames();

			Gamemode=1;
			break;
		case 1:
			curplayer=0;
			for(i=0;i<52;i++) {
				Deck.card[i]=0xff;
			}
			
			for(i=0;i<52;i++) {	// shuffle
				j=Random()%(52-i);
				l=0;
				do {	// find 0'st FF
					if(Deck.card[l]==0xff) break;
					l++;
				} while(1);
				for(k=0;k<j;k++) {
					l++;	// increment to next card
					do { // find k+1'st FF
						if(Deck.card[l]==0xff) break;
						l++;
					} while(1);
				}	// got j'th FF
				Deck.card[l]=i;
			}	// cards shuffled!
			// clear out player's hands
			for(i=0;i<4;i++) {
				player[i].numcards=0;

			}
			// now deal....
			curplayer=(curdealer+1)%4;
			curdealer++;
			for(i=0;i<52;i++) {
				wait_vblank();
				SendPlayerCard(curplayer,Deck.card[51-i]);
				RedrawPlayerHand(curplayer);
				curplayer=(curplayer+1)%4;
			}	// Cards Dealt, Job done, Go to next stage...
			
			Gamemode=2;
			break;
		case 2:
			for(i=0;i<4;i++) {
				RequestPassCards(i,passtype);
				passcards[i]=0;
			}
			do {
				wait_vblank();
				UpdateKeys();
				for(i=0;i<4;i++) {
					if(passcards[i]==0) passcards[i]=GetPassCards(i);
				}
			} while((!passcards[0] || !passcards[1] || !passcards[2] || !passcards[3]));
			for(i=0;i<4;i++) { // kill passed cards
				RemovePlayerCard(i,passcards[i]&255);
				RemovePlayerCard(i,(passcards[i]>>8)&255);
				RemovePlayerCard(i,(passcards[i]>>16)&255);
				RedrawPlayerHand(i);
			}
			for(i=0;i<4;i++) { // add new cards from pass
				switch(passtype) {
				case 0:	// pass left
					temp1=passcards[(i+1)%4];
					break;
				case 1: // pass right
					temp1=passcards[(i+3)%4];
					break;
				case 2: // pass across
					temp1=passcards[(i+2)%4];
					break;
				}
				SendPlayerCard(i,temp1&255);
				SendPlayerCard(i,(temp1>>8)&255);
				SendPlayerCard(i,(temp1>>16)&255);
				RedrawPlayerHand(i);
			}
				passtype=(passtype+1)%3;	// let's go to the next pass type
			Gamemode=3;
			break;


		case 3: // game play mode !!!!
			// who has 2 of clubs?

			curplayer=5;
			for(i=0;i<4;i++) {
				for(j=0;j<13;j++) {
					if(player[i].card[j]==CardNum(SUIT_CLUBS,CARD_TWO))
						curplayer=i;
				}
				if(curplayer<5) break;
			}
			// k will be trick number
			for(k=0;k<13;k++) {
				DrawTrick(k,0);
				for(i=0;i<4;i++) {
					// get cards for trick
					trick[k].card[i]=PlayCard((curplayer+i)%4);
					RemovePlayerCard((curplayer+i)%4,trick[k].card[i]);
					if(GetCardPointValue(trick[k].card[i])!=0) counterplayed=1;
					trick[k].plr[i]=(curplayer+i)%4;
					RedrawPlayerHand((curplayer+i)%4);
					DrawTrick(k,i+1);
					
				}
				for(i=0;i<60*2;i++) {
					wait_vblank();
				}
				// figure out who took it
				l=GetCardTakeValue(trick[k].card[0],CardSuit(trick[k].card[0]));
				trick[k].owner=trick[k].plr[0];
				for(i=1;i<4;i++) {
					if(GetCardTakeValue(trick[k].card[i],CardSuit(trick[k].card[0]))>l) {
						l=GetCardTakeValue(trick[k].card[i],CardSuit(trick[k].card[0]));
						trick[k].owner=trick[k].plr[i];
					}
				} // we now have an owner.
				// who also gets to be the next starter
				ShowHeartsTaken();
				curplayer=trick[k].owner;
			}

			Gamemode=4;
			break;

		case 4:
			killOam();
			ClearBox(0,0,300,300,0,0);
			// calculate new totals here
			l=5;m=0;
			for(i=0;i<13;i++) {
				k=0;
				for(j=0;j<4;j++) {
					k+=GetCardPointValue(trick[i].card[j]);
				}
				trick[i].value=k;
				if(trick[i].owner!=l) {
					l=trick[i].owner;
					m=0;
				}
				if(trick[i].owner==l) m+=k;
			}
			if(m<26) {
				// normal scoring
				for(i=0;i<13;i++)
					player[trick[i].owner].Points+=trick[i].value;

			} else {
				// player l got all the points! everyone else gets
				// 26 points added
				for(i=0;i<4;i++) {
					if(i!=l) player[i].Points+=26;
				}
			};

			SpritePrint(0,20,10,10,"Name",-1,0);
			SpritePrint(5,130,10,10,"Score",-1,0);
			for(i=0;i<4;i++) {
				SpritePrint(10+i*10,20,20+i*10,10,player[i].name,-1,0);
				k=100;
				for(j=0;j<3;j++) {
					l=(player[i].Points/k)%10;
					OamA(50+i*3+j,0)=20+i*10;
					OamA(50+i*3+j,1)=130+10*j;
					OamA(50+i*3+j,2)=512+'0'+l;
					k/=10;
				}
			}
			j=0;	// status (1= someone won)
			k=300;	// low score;
			l=5;	// player with score
			m=0;
			for(i=0;i<4;i++) {
				if(player[i].Points<k) {
					l=i;k=player[i].Points;
					m=0;
				}
				if(player[i].Points==k) m++;
				if(player[i].Points>99) j=1;
			}

			if(j==1) {




			} else {
				// show players in the lead
				for(i=0;i<4;i++) {
					if(player[i].Points==k) {
						SetSprite(100+i,180,20+i*10,17,3,0);
					}
				}

			}
			

			k=0;
			i=0;
			do {
				wait_vblank();
				if(j==0);SpritePrint(70,150,140,10,"Continue",0,0);
				SpritePrint(80,100,140,10,"Exit",1,0);
				UpdateKeys();
					SetOamZoom(3,ZoomSin[(k+16)%32]);
				if(i==0 || j==1) {
					SetOamZoom(0,ZoomSin[(k++)%32]);
					SetOamZoom(1,256);
				} else {
					SetOamZoom(1,ZoomSin[(k++)%32]);
					SetOamZoom(0,256);
				}
				if(KeyPressed(KEY_LF) || KeyPressed(KEY_RT) || KeyPressed(KEY_SEL)) {
					PlayGBCSound(1);
					i=i^1;
				}
				if(KeyPressed(KEY_A) || KeyPressed(KEY_STR))  {
					if(i==0 && j!=1) {
						PlayGBCSound(2);
						break;
					} else {
						PlayGBCSound(3);
						killOam();
						DISPCNT=0;
						return 0;
					}
				}
			} while(1);

				Gamemode=0;

			break;
		}
	} while(1);
	return 0;
}
